/*
 *  RpmViewer.h: 
 *
 *  Copyright (c) 2002 Fabien Vallon <fabien.vallon@fr.alcove.com>
 *  
 *  Author: Enrico Sersale
 *  Date: August 2001
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef RPMVIEWER_H
#define RPMVIEWER_H
#import <AppKit/NSView.h>
#import <Foundation/NSString.h>
#include "ContentViewersProtocol.h"


//b0rk FIXME
static  NSString *RpmExecPath=@"/bin/rpm";

@class NSBox;
@class NSTextField;
@class NSMutableArray;

@protocol ContentInspectorProtocol

- (void)contentsReadyAt:(NSString *)path;

@end 

@interface RpmViewer : NSView <ContentViewersProtocol>
{
  NSString *myPath;
  id panel;
  id buttCancel, buttOk;
  NSTextField *resultPackageName;
  NSTextField *resultPackageMaintainer;
  NSTextField *resultPackageVersion;
  NSTextField *resultPackageUrl;
  NSTextField *resultPackageSize;
  NSTextField *errorLabel;
  NSTextView *resultPackageDescription;

  NSArray *extsarr;
  NSMutableArray *rpmFilesArray;
  NSWorkspace *workspace;
  int index;
  NSString *localizedStr;
  NSString *bundlePath;
  NSString *RpmPath;

  NSButton *editButt;

  id <ContentInspectorProtocol>inspector;

}


-(void) _displayError: (NSString *) error;
-(void) _displayInfo;
@end

#endif // RPMVIEWER_H
